#include <xparameters.h>
#include <xgpio_l.h>
#include <xintc_l.h>
#include <xtmrctr_l.h>
#include <mb_interface.h>


//*****************************************************************************
//* Makrk a memria rshoz s olvasshoz.                                 *
//*****************************************************************************
#define MEM8(addr)   (*(volatile unsigned char *)(addr))
#define MEM16(addr)  (*(volatile unsigned short *)(addr))
#define MEM32(addr)  (*(volatile unsigned long *)(addr))


//*****************************************************************************
//* Defincik a folyadkszint jelz perifrihoz.                            *
//*****************************************************************************
//Sttusz regiszter: 32 bites, csak olvashat
#define LVL_STATUS_REG				0x00
//Megszakts engedlyez regiszter: 32 bites, rhat/olvashat
#define LVL_IE_REG					0x04
//Megszakts flag regiszter: 32 bites, olvashat  s '1' berssal trlhet
#define LVL_IF_REG					0x08

//A folyadkszint jelz perifria megszakts esemnyei.
#define LVL_FULL_IRQ				(1 << 0)
#define LVL_EMPTY_IRQ				(1 << 1)
#define LVL_ERROR_IRQ				(1 << 2)


//*****************************************************************************
//* Htszegmenses dekder.                                                    *
//*****************************************************************************
unsigned char bin2sevenseg[] = {
	0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07,
	0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71
};


//*****************************************************************************
//* Az idzt megszaktskezel rutinja.                                     *
//*****************************************************************************
volatile unsigned char led_value;
volatile unsigned char led_blink;

void timer_int_handler(void *instancePtr)
{
	unsigned long csr;

	//Meghatrozzuk a LED-ekre kirand j rtket s amennyiben engedlyezett
	//a villogs, akkor azt kirjuk a LED-ekre. Ha a villogs nem engedlyezett,
	//akkor a LED-eket kikapcsoljuk.

	//A megszakts jelzs trlse. A jelzs az idzt kontroll/sttusz
	//regiszterben 1 bersval trlhet.
	//XTmrCtr_GetControlStatusReg()
	//XTmrCtr_SetControlStatusReg()
}


//*****************************************************************************
//* A GPIO perifria megszaktskezel rutinja.                               *
//*****************************************************************************
void gpio_int_handler(void *instancePtr)
{
	unsigned char ifr, btn;

	//A megszakts jelzs trlse. A jelzs a GPIO megszakts sttusz
	//regiszterben 1 bersval trlhet.
	//XGpio_ReadReg()
	//XGpio_WriteReg()

	//A GPIO CH2 llapotvltozs megszakts vizsglata. Ha a BTN0 gombot
	//megnyomtk, akkor tiltjuk a LED-ek villogst.
}


//*****************************************************************************
//* A folyadkszint kijelz perifria megszaktskezel rutinja.              *
//*****************************************************************************
void lvl_int_handler(void *instancePtr)
{
	unsigned char ifr;

	//A megszakts jelzs trlse. A jelzs a perifria megszakts flag
	//regiszterben 1 bersval trlhet.

	//Hibajelzs esetn engedlyezzk a LED-ek villogst.
}


//*****************************************************************************
//* Fprogram.                                                                *
//*****************************************************************************
int main()
{
	unsigned long data;

	led_value = 0;
	led_blink = 0;

	//A megszaktskezel rutinok regisztrlsa.
	//XIntc_RegisterHandler()


	//A hasznlt megszaktsok engedlyezse a megszakts vezrlben.
	//XIntc_MasterEnable()
	//XIntc_EnableIntr()


	//A CH2 llapotvltozs megszakts engedlyezse a kapcsol/nyomgomb GPIO perifriban:
	//CH2 flag trlse, CH2 megszakts engedlyezs, globlis megszakts engedlyezs.
	//XGpio_WriteReg()

	//A hiba megszakts engedlyezse a folyadkszint kijelz perifriban:
	//ERROR flag trlse, ERROR megszakts engedlyezse.

	//A megszaktsok engedlyezse a MicroBlaze processzoron.
	//microblaze_enable_interrupts()

	//A timer LOAD regiszternek belltsa (megszakts 0,25 msodpercenknt).
	//XTmrCtr_SetLoadReg()

	//A timer alapllapotba lltsa:
	//- a timer lelltsa
	//- a megszakts jelzs trlse
	//- a LOAD regiszter betltse a szmllba
	//XTmrCtr_SetControlStatusReg()

	//A timer elindtsa:
	//- a timer engedlyezse
	//- a megszakts engedlyezse
	//- automatikus szmll jratlts (periodikus) md
	//- a szmll lefele szmll (0 a vgllapot)
	//XTmrCtr_SetControlStatusReg()


	//A vgtelen ciklusban folyamatosan beolvassuk a folyadkszint
	//rtkt s kijelezzk a htszegmenses kijelz DIG0 digitjre.
	for (;;)
	{

	}

	return 0;
}
